--- old/usr/src/cmd/sgs/libld/common/libld.msg	Sun May  4 06:58:06 2014
+++ new/usr/src/cmd/sgs/libld/common/libld.msg	Sun May  4 06:58:06 2014
@@ -180,7 +180,7 @@
 			 nounused\n"
 @ MSG_ARG_DETAIL_ZH	"\t[-z help], [--help]\n\
 			 \t\t\tprint this usage message\n"
-@ MSG_ARG_DETAIL_ZIG	"\t[-z ignore | record]\n\
+@ MSG_ARG_DETAIL_ZIG	"\t[-z ignore | record], [--as-needed | --no-as-needed]\n\
 			 \t\t\tignore|record unused dynamic dependencies\n"
 @ MSG_ARG_DETAIL_ZINA	"\t[-z initarray=function]\n\
 			 \t\t\tname of function to be appended to the \
@@ -1446,6 +1446,7 @@
 @ MSG_ARG_T_SONAME	"soname"
 @ MSG_ARG_T_WL		"l,-"
 
+@ MSG_ARG_T_ASNEEDED	"-as-needed"
 @ MSG_ARG_T_AUXFLTR	"-auxiliary"
 @ MSG_ARG_T_MULDEFS	"-allow-multiple-definition"
 @ MSG_ARG_T_INTERP	"-dynamic-linker"
@@ -1457,6 +1458,7 @@
 @ MSG_ARG_T_HELP	"-help"
 @ MSG_ARG_T_LIBRARY	"-library"
 @ MSG_ARG_T_LIBPATH	"-library-path"
+@ MSG_ARG_T_NOASNEEDED	"-no-as-needed"
 @ MSG_ARG_T_NOUNDEF	"-no-undefined"
 @ MSG_ARG_T_NOWHOLEARC	"-no-whole-archive"
 @ MSG_ARG_T_OUTPUT	"-output"
--- old/usr/src/cmd/sgs/libld/common/util.c	Sun May  4 06:58:06 2014
+++ new/usr/src/cmd/sgs/libld/common/util.c	Sun May  4 06:58:06 2014
@@ -460,6 +460,16 @@
 			switch (*(arg + 1)) {
 			case 'a':
 				/*
+				 * Translate --as-needed to -zignore
+				 */
+				if ((c = str2chr(lml, ndx, argc, argv, arg, 'z',
+				    MSG_ORIG(MSG_ARG_T_ASNEEDED), 0, NULL)) !=
+				    0) {
+					optarg =
+					    (char *)MSG_ORIG(MSG_ARG_IGNORE);
+					return (c);
+				}
+				/*
 				 * Translate --allow-multiple-definition to
 				 * -zmuldefs
 				 */
@@ -469,12 +479,12 @@
 					optarg =
 					    (char *)MSG_ORIG(MSG_ARG_MULDEFS);
 					return (c);
-
+				}
 				/*
 				 * Translate --auxiliary <optarg> to
 				 * -f <optarg>
 				 */
-				} else if ((c = str2chr(lml, argc, ndx, argv,
+				if ((c = str2chr(lml, argc, ndx, argv,
 				    arg, 'f', MSG_ORIG(MSG_ARG_T_AUXFLTR),
 				    MSG_ARG_T_AUXFLTR_SIZE, NULL)) != 0) {
 					return (c);
@@ -558,6 +568,16 @@
 				break;
 			case 'n':
 				/*
+				 * Translate --no-as-needed to -zrecord
+				 */
+				if ((c = str2chr(lml, ndx, argc, argv, arg, 'z',
+				    MSG_ORIG(MSG_ARG_T_NOASNEEDED), 0, NULL)) !=
+				    0) {
+					optarg =
+					    (char *)MSG_ORIG(MSG_ARG_RECORD);
+					return (c);
+				}
+				/*
 				 * Translate --no-fatal-warnings to
 				 * -z nofatal-warnings.
 				 */
--- old/usr/src/man/man1/ld.1	Sun May  4 06:58:07 2014
+++ new/usr/src/man/man1/ld.1	Sun May  4 06:58:07 2014
@@ -1126,6 +1126,10 @@
 .na
 \fB\fB-z\fR \fBignore\fR | \fBrecord\fR\fR
 .ad
+.br
+.na
+\fB\fB--as-needed\fR | \fB--no-as-needed\fR\fR
+.ad
 .sp .6
 .RS 4n
 Ignores, or records, dynamic dependencies that are not referenced as part of
